"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.tsx
var src_exports = {};
__export(src_exports, {
  ErrorBoundary: () => ErrorBoundary,
  SampleBuggyButton: () => SampleBuggyButton
});
module.exports = __toCommonJS(src_exports);

// src/components/ErrorBoundary/ErrorBoundary.tsx
var import_react2 = __toESM(require("react"));

// src/components/ReportDialog/ReportDialog.tsx
var import_react = __toESM(require("react"));
var ReportDialog = ({
  labelClose = "Close",
  labelComments = "What happened?",
  labelEmail = "Email",
  labelName = "Name",
  labelSubmit = "Submit",
  subtitle2 = "If you\u2019d like to help, tell us what happened below.",
  subtitle = "Our team has been notified.",
  successMessage = "Your feedback has been sent. Thank you!",
  successSubtitle = "Thank you for sending us feedback. If you have any other concerns/questions, reach out to this application's support email.",
  title = "It looks like we\u2019re having issues.",
  placeholderComments = "I typed in a name then clicked the button",
  user,
  onCloseHandler,
  onSubmitHandler,
  hideHighlightBranding = false
}) => {
  const [name, setName] = (0, import_react.useState)((user == null ? void 0 : user.name) || "");
  const [email, setEmail] = (0, import_react.useState)((user == null ? void 0 : user.email) || "");
  const [verbatim, setVerbatim] = (0, import_react.useState)("");
  const [sendingReport, setSendingReport] = (0, import_react.useState)(false);
  const [sentReport, setSentReport] = (0, import_react.useState)(false);
  const reportDialogOpenTime = (0, import_react.useRef)((/* @__PURE__ */ new Date()).toISOString());
  const handleSubmit = (event) => {
    var _a;
    event.preventDefault();
    setSendingReport(true);
    if ((_a = window == null ? void 0 : window.H) == null ? void 0 : _a.addSessionFeedback) {
      window.H.addSessionFeedback({
        verbatim,
        userName: name,
        userEmail: email,
        timestampOverride: reportDialogOpenTime.current
      });
    } else {
      console.warn(
        "Highlight is not initialized. Make sure highlight.run is installed and running."
      );
    }
    new Promise((r) => window.setTimeout(r, 300)).then(() => {
      setSendingReport(false);
      setSentReport(true);
      if (onSubmitHandler) {
        onSubmitHandler();
      }
    });
  };
  return /* @__PURE__ */ import_react.default.createElement("main", { className: `container` }, /* @__PURE__ */ import_react.default.createElement("div", { className: `card` }, /* @__PURE__ */ import_react.default.createElement(
    "div",
    {
      className: `cardContents ${sentReport && "cardContentsVisible"}`
    },
    /* @__PURE__ */ import_react.default.createElement("h1", { className: `title` }, successMessage),
    /* @__PURE__ */ import_react.default.createElement("h4", { className: `subtitle` }, successSubtitle),
    /* @__PURE__ */ import_react.default.createElement(
      "button",
      {
        className: `button confirmationButton`,
        onClick: onCloseHandler
      },
      "Close"
    )
  ), /* @__PURE__ */ import_react.default.createElement(
    "div",
    {
      className: `cardContents ${!sentReport && "cardContentsVisible"}`
    },
    /* @__PURE__ */ import_react.default.createElement("div", null, /* @__PURE__ */ import_react.default.createElement("h1", { className: `title` }, title), /* @__PURE__ */ import_react.default.createElement("h2", { className: `subtitle` }, subtitle, " ", subtitle2)),
    /* @__PURE__ */ import_react.default.createElement("form", { className: `form`, onSubmit: handleSubmit }, /* @__PURE__ */ import_react.default.createElement("label", null, labelName, /* @__PURE__ */ import_react.default.createElement(
      "input",
      {
        type: "text",
        value: name,
        name: "name",
        autoFocus: true,
        onChange: (e) => {
          setName(e.target.value);
        }
      }
    )), /* @__PURE__ */ import_react.default.createElement("label", null, labelEmail, /* @__PURE__ */ import_react.default.createElement(
      "input",
      {
        type: "email",
        value: email,
        name: "email",
        onChange: (e) => {
          setEmail(e.target.value);
        }
      }
    )), /* @__PURE__ */ import_react.default.createElement("label", null, labelComments, /* @__PURE__ */ import_react.default.createElement(
      "textarea",
      {
        value: verbatim,
        placeholder: placeholderComments,
        name: "verbatim",
        rows: 3,
        onChange: (e) => {
          setVerbatim(e.target.value);
        }
      }
    )), /* @__PURE__ */ import_react.default.createElement("div", { className: `formFooter` }, /* @__PURE__ */ import_react.default.createElement("div", { className: `formActionsContainer` }, /* @__PURE__ */ import_react.default.createElement(
      "button",
      {
        type: "submit",
        className: sendingReport ? `button loadingButton` : "button"
      },
      labelSubmit
    ), /* @__PURE__ */ import_react.default.createElement(
      "button",
      {
        className: `button closeButton`,
        onClick: onCloseHandler,
        type: "button"
      },
      labelClose
    )), !hideHighlightBranding && /* @__PURE__ */ import_react.default.createElement("div", { className: `ad` }, /* @__PURE__ */ import_react.default.createElement("p", { className: `logoContainer` }, "Crash reports powered by:", /* @__PURE__ */ import_react.default.createElement(
      "a",
      {
        href: "https://highlight.run",
        target: "_blank"
      },
      /* @__PURE__ */ import_react.default.createElement(
        "img",
        {
          src: "https://app.highlight.run/logo-24x130.png",
          alt: "Highlight",
          height: "25",
          className: `logo`
        }
      )
    )))))
  )));
};
var ReportDialog_default = ReportDialog;

// src/components/ErrorBoundary/ErrorBoundary.tsx
var INITIAL_STATE = {
  componentStack: null,
  error: null,
  showingDialog: false
};
var ErrorBoundary = class extends import_react2.default.Component {
  constructor() {
    super(...arguments);
    this.state = INITIAL_STATE;
    this.resetErrorBoundary = () => {
      const { onReset } = this.props;
      const { error, componentStack } = this.state;
      if (onReset) {
        onReset(error, componentStack);
      }
      this.setState(INITIAL_STATE);
    };
    this.hideDialog = () => {
      this.setState(__spreadProps(__spreadValues({}, this.state), { showingDialog: false }));
      if (this.props.onAfterReportDialogCancelHandler) {
        this.props.onAfterReportDialogCancelHandler();
      }
    };
    this.onReportDialogSubmitHandler = () => {
      if (this.props.onAfterReportDialogSubmitHandler) {
        this.props.onAfterReportDialogSubmitHandler();
      }
    };
  }
  componentDidCatch(error, errorInfo) {
    const { beforeCapture, onError, showDialog } = this.props;
    if (beforeCapture) {
      beforeCapture(error, errorInfo.componentStack);
    }
    captureReactErrorBoundaryError(error, errorInfo.componentStack);
    if (onError) {
      onError(error, errorInfo.componentStack);
    }
    if (showDialog) {
      this.setState(__spreadProps(__spreadValues({}, this.state), { showingDialog: true }));
    }
    this.setState({ error, componentStack: errorInfo.componentStack });
  }
  componentDidMount() {
    const { onMount } = this.props;
    if (onMount) {
      onMount();
    }
  }
  componentWillUnmount() {
    const { error, componentStack } = this.state;
    const { onUnmount } = this.props;
    if (onUnmount) {
      onUnmount(error, componentStack);
    }
  }
  render() {
    const { fallback, children, customDialog } = this.props;
    const { error, componentStack, showingDialog } = this.state;
    if (error) {
      let element = void 0;
      if (typeof fallback === "function") {
        element = fallback({
          error,
          componentStack,
          resetError: this.resetErrorBoundary
        });
      } else {
        element = fallback;
      }
      if (import_react2.default.isValidElement(element)) {
        return /* @__PURE__ */ import_react2.default.createElement(import_react2.default.Fragment, null, showingDialog && /* @__PURE__ */ import_react2.default.createElement(
          ReportDialog_default,
          __spreadProps(__spreadValues({}, this.props.dialogOptions), {
            onCloseHandler: this.hideDialog,
            onSubmitHandler: this.onReportDialogSubmitHandler
          })
        ), element);
      }
      if (fallback) {
        console.warn("fallback did not produce a valid ReactElement");
      }
      if (showingDialog && customDialog) {
        return customDialog;
      }
      return showingDialog && /* @__PURE__ */ import_react2.default.createElement(
        ReportDialog_default,
        __spreadProps(__spreadValues({}, this.props.dialogOptions), {
          onCloseHandler: this.hideDialog,
          onSubmitHandler: this.onReportDialogSubmitHandler
        })
      );
    }
    if (typeof children === "function") {
      return children();
    }
    return children;
  }
};
function captureReactErrorBoundaryError(error, componentStack) {
  const errorBoundaryError = new Error(` ${error.message}`);
  errorBoundaryError.name = `React ErrorBoundary ${error.name}`;
  errorBoundaryError.stack = error.stack;
  const componentName = getComponentNameFromStack(componentStack);
  if (!window.H) {
    console.warn("You need to install highlight.run as a npm dependency.");
  } else {
    window.H.consumeError(
      errorBoundaryError,
      `${componentName ? `ErrorBoundary ${componentName}` : "HighlightErrorBoundary"}`
    );
  }
}
function getComponentNameFromStack(componentStack) {
  const stack = componentStack.split("\n");
  if (stack.length < 1) {
    return void 0;
  }
  const leafComponentLine = stack[1].trim();
  const tokens = leafComponentLine.split(" ");
  if (tokens.length !== 4) {
    return void 0;
  }
  return `<${tokens[1]}>`;
}

// src/components/SampleBuggyButton/SampleBuggyButton.tsx
var import_react3 = __toESM(require("react"));
var SampleBuggyButton = ({
  children
}) => {
  const [isError, setError] = import_react3.default.useState(false);
  if (isError) {
    throw new Error("something bad happened - this is a sample test error");
  }
  return /* @__PURE__ */ import_react3.default.createElement(
    "button",
    {
      type: "button",
      className: "buggyButton",
      onClick: () => setError(true)
    },
    children != null ? children : "Throw an Error"
  );
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ErrorBoundary,
  SampleBuggyButton
});
